- [HTTP request](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#body.HTTP_TEMPLATE)
- [Request body](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#body.request_body)
  - [JSON representation](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#body.response_body)
- [AsynchronousCancelFundsReservationResponse](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#AsynchronousCancelFundsReservationResponse)
  - [JSON representation](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#AsynchronousCancelFundsReservationResponse.SCHEMA_REPRESENTATION)
- [AsynchronousCancelFundsReservationResultCode](https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#AsynchronousCancelFundsReservationResultCode)

Initiates canceling the funds that were previously reserved in a call to `https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/reserveFunds#google.standardpayments.flows.card_fop_reserve_capture.v1.PaymentIntegratorCardReserveCaptureService.ReserveFunds`.

This cancels the pending transaction by freeing the reserved funds. The `reservationRequestId` identifies which funds reservation is being canceled. When this is used, there is no money movement from a customer's account for this transaction. The final result of the cancel is supplied by a call to `cancelFundsReservationResultNotification`. The `requestId` within the header is the idempotency key and uniquely identifies this transaction.

If the reservation of funds has expired or the payment integrator has automatically canceled the reservation, consider it a successful cancel rather than an error. Therefore, return an `ACKNOWLEDGED` response code and call `cancelFundsReservationResultNotification`.

If the endpoint encounters an error while processing the request, the response body from this endpoint should be of type `https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ErrorResponse`.

An example request looks like:


    {
      "requestHeader": {
        "protocolVersion": {
          "major": 1,
          "minor": 0,
          "revision": 0
        },
        "requestId": "G1NMPDFX4AW395L",
        "requestTimestamp": "1481907920000"
      },
      "paymentIntegratorAccountId": "SpeedyPaymentsIndia_INR",
      "reservationRequestId": "G1MQ0YERJ0Q7LPM"
    }

An example response looks like:


    {
      "responseHeader": {
        "responseTimestamp": "1481907920760"
      },
      "result": "ACKNOWLEDGED"
    }

### HTTP request

`POST https://www.integratorhost.example.com/integrator-base-path/v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation`

### Request body

The request body contains data with the following structure:

| JSON representation |
|---|
| ``` { "requestHeader": { object (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/RequestHeader`) }, "paymentIntegratorAccountId": string, "reservationRequestId": string } ``` |

| Fields ||
|---|---|
| `requestHeader` | ``object (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/RequestHeader`)`` **REQUIRED**: Common header for all requests. |
| `paymentIntegratorAccountId` | `string` **REQUIRED**: This is the payment integrator account identifier that identifies contractual constraints around this transaction. |
| `reservationRequestId` | `string` **REQUIRED** : A unique identifier for this transaction. This is the `requestId` generated by Google during the `reserveFunds` or `verifyCardWithMinimumReservation` calls which this request is associated with. |

### Response body

This method supports multiple return types. For additional information about what 4XX or 5XX HTTP status code to return with an `ErrorResponse`, consult the `ErrorResponse` object and [HTTP status codes documentation](https://developers.google.com/pay/card-fop-v1/guides/connectivity/protocol-standards#http_status_codes).

| Possible response messages ||
|---|---|
| HTTP 200 Status | ``object (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#AsynchronousCancelFundsReservationResponse`)`` |
| HTTP 4XX / 5XX Status | ``object (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ErrorResponse`)`` |
| End of mutually exclusive fields. ||

## AsynchronousCancelFundsReservationResponse

Response object for the payment integrator hosted card-fop-v1.asynchronousCancelFundsReservation method.

| JSON representation |
|---|
| ``` { "responseHeader": { object (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ResponseHeader`) }, "result": enum (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#AsynchronousCancelFundsReservationResultCode`) } ``` |

| Fields ||
|---|---|
| `responseHeader` | ``object (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/ResponseHeader`)`` **REQUIRED**: Common header for all responses. |
| `result` | ``enum (`https://developers.google.com/pay/card-fop-v1/payment-integrator-card-fop-api/asynchronousCancelFundsReservation#AsynchronousCancelFundsReservationResultCode`)`` **REQUIRED** : The result of the `asynchronousCancelFundsReservation` call. |

## AsynchronousCancelFundsReservationResultCode

Result codes for `asynchronousCancelFundsReservation`.

| Enums ||
|---|---|
| `ASYNCHRONOUS_CANCEL_FUNDS_RESERVATION_RESULT_CODE_UNSPECIFIED` | Do not ever set this default value! |
| `ACKNOWLEDGED` | The cancel has been requested and the integrator will do additional steps to determine if the cancel was successful. Once the integrator knows the result of the cancel, they must inform Google of the result by calling the `cancelFundsReservationNotification` API. |